﻿// ---------------------------------------------------------------------------------
// 
// Sample code is copyright (c) Education Software Solutions Ltd 2021
// 
// Education Software Solutions (Hereafter 'ESS') provide sample code to 
// ESS Technical Integrators (Hereafter 'TIs') under consultancy 
// or as part of our TI programme to assist in the production of applications and services
// to benefit mutual customers.
// 
// Sample code is supplied by the ESS TI Team and may be augmented / changed at any time.
//
// ESS grants non exclusive rights to use the code on an 'as is' basis to contracted TIs 
// for the purpose of interfacing with ESS Products.  Code may be used in whole or in part 
// for the TIs products. Rights are subject to the restrictions below.
//
// This code may not be used for commercial purposes without a current TI agreement   
// in place with ESS.  The use of any sample code may incur liabilities for TI contractual 
// fees.  
//
// If the code is provided to eductational establishments for their own use then further 
// consent from ESS must be obtained before the code can be re-used for commercial gain.
//
// No warranty is provided . This header must be retained within the code and Copyright acknowleged as
// Parts (c) Education Software Solutions Ltd 2021 in version info.
//
// Code samples may be used to support other partners and no exclusivity is implied herein
//
// ---------------------------------------------------------------------------------

using System;
using System.IO;
using System.Diagnostics;

namespace PostitCommon
{
    public class Log
    {
        /// <summary>
        /// Set the location of the log file before use!
        /// </summary>
        public static string LogFile = "";
        public static bool DebugState = false;
        public static void Debug(string Message)
        {
            if (DebugState)
            {
                Write("<Verbose> " + Message);
            }
        }
        /// <summary>
        /// Write a message to the log file.
        /// </summary>
        /// <param name="Message"></param>
        public static void Write(string Message)
        {
            if (!string.IsNullOrEmpty(LogFile))
            {
                FileInfo fi = new FileInfo(LogFile);
                if (!fi.Directory.Exists)
                {
                    fi.Directory.Create();
                }
                using (StreamWriter sw = new StreamWriter(LogFile, true))
                {
                    sw.WriteLine(DateTime.Now.ToShortDateString() + "\t" + DateTime.Now.ToShortTimeString() + "\t" + Environment.UserDomainName + "\\" + Environment.UserName + "\t" + Message);
                    sw.Flush();
                    sw.Close();
                }
            }
            else
            {
                throw new ArgumentNullException("Must define the log file name before using it!");
            }
        }
        /// <summary>
        /// Write a message to the log file.
        /// </summary>
        /// <param name="Message"></param>
        public static void WriteShort(string Message)
        {
            if (!string.IsNullOrEmpty(LogFile))
            {
                FileInfo fi = new FileInfo(LogFile);
                if (!fi.Directory.Exists)
                {
                    fi.Directory.Create();
                }
                using (StreamWriter sw = new StreamWriter(LogFile, true))
                {
                    sw.WriteLine(Message);
                    sw.Flush();
                    sw.Close();
                }
            }
            else
            {
                throw new ArgumentNullException("Must define the log file name before using it!");
            }
        }
        public static void Show()
        {
            Process p = new Process();
            p.StartInfo.FileName = "Notepad";
            p.StartInfo.Arguments = LogFile;
            p.StartInfo.ErrorDialog = false;
            p.Start();
        }
    }
}
