﻿// ---------------------------------------------------------------------------------
// 
// Sample code is copyright (c) Education Software Solutions Ltd 2021
// 
// Education Software Solutions (Hereafter 'ESS') provide sample code to 
// ESS Technical Integrators (Hereafter 'TIs') under consultancy 
// or as part of our TI programme to assist in the production of applications and services
// to benefit mutual customers.
// 
// Sample code is supplied by the ESS TI Team and may be augmented / changed at any time.
//
// ESS grants non exclusive rights to use the code on an 'as is' basis to contracted TIs 
// for the purpose of interfacing with ESS Products.  Code may be used in whole or in part 
// for the TIs products. Rights are subject to the restrictions below.
//
// This code may not be used for commercial purposes without a current TI agreement   
// in place with ESS.  The use of any sample code may incur liabilities for TI contractual 
// fees.  
//
// If the code is provided to eductational establishments for their own use then further 
// consent from ESS must be obtained before the code can be re-used for commercial gain.
//
// No warranty is provided . This header must be retained within the code and Copyright acknowleged as
// Parts (c) Education Software Solutions Ltd 2021 in version info.
//
// Code samples may be used to support other partners and no exclusivity is implied herein
//
// ---------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Text;

namespace SIMS8V3Models
{
    public class TLoggedCommunication : TMailboxBase
    {
        public Nullable<DateTime> CommunicationDateTime;
        public string Content;
        public TCommunicationImportanceEnum CommunicationImportance;
        public TCommunicationCategoryRef CommunicationCategory;
        public List<TCommunicationAssociationRef> Associations;
    }
    public class TCommunicationImportanceEnum : TReferenceClass { }
    public class TCommunicationMethodRef : TReferenceClass { }
    public class TCommunicationCategoryRef : TReferenceClass { }
    public class TCommunicationSenderRef : TReferenceClass { }
    public class TCommunicationRecipientRef : TReferenceClass { }
    public class TCommunicationAssociationRef : TReferenceClass { }
    public class TCommunicationLookups : TLookups { }
    public class TMailboxMessage :TMailboxBase
    {
        public Nullable<DateTime> MessageDateTime;
        public string FromAddress;
        public TCommunicationImportanceEnum Importance;
        public Nullable<bool> LogMessage;
        public string MessageContentURL;
        public TCommunicationCategoryRef MessageCategory;
        public Nullable<int> MessageDirection;
    }
    public abstract class TMailboxBase
    {
        public Guid ExternalID;
        public string Summary;
        public string Subject;
        public Nullable<Guid> Conversation;
        public Nullable<bool> IsEditable;
        public Nullable<Guid> ReplyTo;
        public TCommunicationMethodRef CommunicationMethod;
        public TCommunicationSenderRef Sender;
        public List<TCommunicationRecipientRef> Recipients;
        public List<TCommunicationAssociationRef> RelatesTo;
        }

}
/*
<? xml version="1.0" encoding="utf-8"?>
<edmx:Edmx Version = "4.0" xmlns:edmx="http://docs.oasis-open.org/odata/ns/edmx">
    <edmx:DataServices>
        <Schema Namespace = "SIMS" xmlns="http://docs.oasis-open.org/odata/ns/edm">
            <EntityType Name = "MailboxMessage" >
                < Key >
                    < PropertyRef Name="ExternalID" />
                </Key>
                <Property Name = "ExternalID" Type="Edm.Guid" Nullable="false" />
                <Property Name = "MessageDateTime" Type="Edm.DateTimeOffset" />
                <Property Name = "FromAddress" Type="Edm.String" />
                <Property Name = "Summary" Type="Edm.String" />
                <Property Name = "Subject" Type="Edm.String" />
                <Property Name = "IsEditable" Type="Edm.Boolean" />
                <Property Name = "Conversation" Type="Edm.Guid" />
                <Property Name = "ReplyTo" Type="Edm.Guid" />
                <Property Name = "Importance" Type="SIMS.CommunicationImportanceEnum" Nullable="false" />
                <Property Name = "LogMessage" Type="Edm.Boolean" />
                <Property Name = "MessageContentURL" Type="Edm.String" />
                <Property Name = "CommunicationMethod" Type="SIMS.CommunicationMethodRef" Nullable="false" />
                <Property Name = "MessageCategory" Type="SIMS.CommunicationCategoryRef" Nullable="false" />
                <Property Name = "Sender" Type="SIMS.CommunicationSenderRef" Nullable="false" />
                <Property Name = "Recipients" Type="Collection(SIMS.CommunicationRecipientRef)" Nullable="false" />
                <Property Name = "RelatesTo" Type="Collection(SIMS.CommunicationAssociationRef)" />
                <Property Name = "MessageDirection" Type="Edm.Int32" />
            </EntityType><EntityType Name = "CommunicationLookups" >
                < Key >
                    < PropertyRef Name="ExternalID" />
                    <PropertyRef Name = "LookupType" />
                </ Key >
                < Property Name="ExternalID" Type="Edm.Guid" Nullable="false" />
                <Property Name = "LookupType" Type="SIMS.LookupType" Nullable="false" />
                <Property Name = "ResourceProvider" Type="SIMS.ResourceProviderRef" />
                <Property Name = "Code" Type="Edm.String" />
                <Property Name = "Description" Type="Edm.String" />
                <Property Name = "DisplayOrder" Type="Edm.Int32" Nullable="false" />
                <Property Name = "IsVisible" Type="Edm.Boolean" />
            </EntityType>
            <EntityType Name = "LoggedCommunication" >
                < Key >
                    < PropertyRef Name="ExternalID" />
                </Key>
                <Property Name = "ExternalID" Type="Edm.Guid" Nullable="false" />
                <Property Name = "CommunicationDateTime" Type="Edm.DateTimeOffset" />
                <Property Name = "Summary" Type="Edm.String" />
                <Property Name = "Subject" Type="Edm.String" />
                <Property Name = "IsEditable" Type="Edm.Boolean" />
                <Property Name = "Content" Type="Edm.String" />
                <Property Name = "Conversation" Type="Edm.Guid" />
                <Property Name = "ReplyTo" Type="Edm.Guid" />
                <Property Name = "CommunicationImportance" Type="SIMS.CommunicationImportanceEnum" Nullable="false" />
                <Property Name = "CommunicationMethod" Type="SIMS.CommunicationMethodRef" Nullable="false" />
                <Property Name = "CommunicationCategory" Type="SIMS.CommunicationCategoryRef" Nullable="false" />
                <Property Name = "Sender" Type="SIMS.CommunicationSenderRef" Nullable="false" />
                <Property Name = "Recipients" Type="Collection(SIMS.CommunicationRecipientRef)" Nullable="false" />
                <Property Name = "Associations" Type="Collection(SIMS.CommunicationAssociationRef)" />
            </EntityType>
            
            <ComplexType Name = "CommunicationMethodRef" >
                < Property Name="ExternalID" Type="Edm.Guid" Nullable="false" />
                <Property Name = "Type" Type="Edm.String" />
            </ComplexType>
            <ComplexType Name = "CommunicationCategoryRef" >
                < Property Name="ExternalID" Type="Edm.Guid" Nullable="false" />
                <Property Name = "Type" Type="Edm.String" />
            </ComplexType>
            <ComplexType Name = "CommunicationSenderRef" >
                < Property Name="ExternalID" Type="Edm.Guid" Nullable="false" />
                <Property Name = "Type" Type="Edm.String" />
            </ComplexType>
            <ComplexType Name = "CommunicationRecipientRef" >
                < Property Name="ToAddress" Type="Edm.String" />
                <Property Name = "ExternalID" Type="Edm.Guid" Nullable="false" />
                <Property Name = "Type" Type="Edm.String" />
            </ComplexType>
            <ComplexType Name = "CommunicationAssociationRef" >
                < Property Name="ExternalID" Type="Edm.Guid" Nullable="false" />
                <Property Name = "Type" Type="Edm.String" />
            </ComplexType>
            <ComplexType Name = "ResourceProviderRef" >
                < Property Name="ExternalID" Type="Edm.Guid" Nullable="false" />
                <Property Name = "Type" Type="Edm.String" />
            </ComplexType>
            <EntityType Name = "CommunicationCategory" BaseType="SIMS.CommunicationLookups" />
            <EntityType Name = "CommunicationMethod" BaseType="SIMS.CommunicationLookups" />
            <EnumType Name = "LookupType" >
                < Member Name="CommunicationMethod" Value="0" />
                <Member Name = "CommunicationCategory" Value="1" />
            </EnumType>
            <EnumType Name = "CommunicationImportanceEnum" >
                < Member Name="Medium" Value="0" />
                <Member Name = "High" Value="1" />
                <Member Name = "Low" Value="2" />
            </EnumType>
            <Function Name = "Changes" IsBound="true">
                <Parameter Name = "bindingParameter" Type="Collection(SIMS.LoggedCommunication)" />
                <Parameter Name = "startDate" Type="Edm.DateTimeOffset" Nullable="false" />
                <ReturnType Type = "Collection(SIMS.LoggedCommunication)" />
            </ Function >
            < Action Name="Import" IsBound="true">
                <Parameter Name = "bindingParameter" Type="Collection(SIMS.LoggedCommunication)" />
                <Parameter Name = "LoggedCommunications" Type="Collection(SIMS.LoggedCommunication)" />
                <ReturnType Type = "SIMS.LoggedCommunication" />
            </ Action >
            < Function Name="Changes" IsBound="true">
                <Parameter Name = "bindingParameter" Type="Collection(SIMS.CommunicationLookups)" />
                <Parameter Name = "startDate" Type="Edm.DateTimeOffset" Nullable="false" />
                <ReturnType Type = "Collection(SIMS.CommunicationLookups)" />
            </ Function >
            < Action Name="Import" IsBound="true">
                <Parameter Name = "bindingParameter" Type="Collection(SIMS.CommunicationLookups)" />
                <Parameter Name = "CommunicationLookups" Type="Collection(SIMS.CommunicationLookups)" />
                <ReturnType Type = "SIMS.CommunicationLookups" />
            </ Action >
            < Function Name="Changes" IsBound="true">
                <Parameter Name = "bindingParameter" Type="Collection(SIMS.MailboxMessage)" />
                <Parameter Name = "startDate" Type="Edm.DateTimeOffset" Nullable="false" />
                <ReturnType Type = "Collection(SIMS.MailboxMessage)" />
            </ Function >
            < Action Name="Import" IsBound="true">
                <Parameter Name = "bindingParameter" Type="Collection(SIMS.MailboxMessage)" />
                <Parameter Name = "MailboxMessages" Type="Collection(SIMS.MailboxMessage)" />
                <ReturnType Type = "SIMS.MailboxMessage" />
            </ Action >
            < EntityContainer Name="Container">
                <EntitySet Name = "LoggedCommunications" EntityType="SIMS.LoggedCommunication">
                    <Annotation Term = "Org.OData.Capabilities.V1.FilterRestrictions" >
                        < Record >
                            < PropertyValue Property="Filterable" Bool="true" />
                            <PropertyValue Property = "RequiresFilter" Bool="true" />
                            <PropertyValue Property = "RequiredProperties" >
                                < Collection />
                            </ PropertyValue >
                            < PropertyValue Property="NonFilterableProperties">
                                <Collection>
                                    <PropertyPath>Content</PropertyPath>
                                </Collection>
                            </PropertyValue>
                        </Record>
                    </Annotation>
                    <Annotation Term = "Org.OData.Capabilities.V1.SortRestrictions" >
                        < Record >
                            < PropertyValue Property="Sortable" Bool="true" />
                            <PropertyValue Property = "AscendingOnlyProperties" >
                                < Collection />
                            </ PropertyValue >
                            < PropertyValue Property="DescendingOnlyProperties">
                                <Collection />
                            </PropertyValue>
                            <PropertyValue Property = "NonSortableProperties" >
                                < Collection >
                                    < PropertyPath > Content </ PropertyPath >
                                </ Collection >
                            </ PropertyValue >
                        </ Record >
                    </ Annotation >
                </ EntitySet >
                < EntitySet Name="CommunicationLookups" EntityType="SIMS.CommunicationLookups" />
                <EntitySet Name = "MailboxMessages" EntityType="SIMS.MailboxMessage">
                    <Annotation Term = "Org.OData.Capabilities.V1.FilterRestrictions" >
                        < Record >
                            < PropertyValue Property="Filterable" Bool="true" />
                            <PropertyValue Property = "RequiresFilter" Bool="true" />
                            <PropertyValue Property = "RequiredProperties" >
                                < Collection />
                            </ PropertyValue >
                            < PropertyValue Property="NonFilterableProperties">
                                <Collection>
                                    <PropertyPath>MessageContentURL</PropertyPath>
                                </Collection>
                            </PropertyValue>
                        </Record>
                    </Annotation>
                    <Annotation Term = "Org.OData.Capabilities.V1.SortRestrictions" >
                        < Record >
                            < PropertyValue Property="Sortable" Bool="true" />
                            <PropertyValue Property = "AscendingOnlyProperties" >
                                < Collection />
                            </ PropertyValue >
                            < PropertyValue Property="DescendingOnlyProperties">
                                <Collection />
                            </PropertyValue>
                            <PropertyValue Property = "NonSortableProperties" >
                                < Collection >
                                    < PropertyPath > MessageContentURL </ PropertyPath >
                                </ Collection >
                            </ PropertyValue >
                        </ Record >
                    </ Annotation >
                </ EntitySet >
            </ EntityContainer >
        </ Schema >
    </ edmx:DataServices>
</edmx:Edmx>
*/
