﻿// ---------------------------------------------------------------------------------
// 
// Sample code is copyright (c) Education Software Solutions Ltd 2021
// 
// Education Software Solutions (Hereafter 'ESS') provide sample code to 
// ESS Technical Integrators (Hereafter 'TIs') under consultancy 
// or as part of our TI programme to assist in the production of applications and services
// to benefit mutual customers.
// 
// Sample code is supplied by the ESS TI Team and may be augmented / changed at any time.
//
// ESS grants non exclusive rights to use the code on an 'as is' basis to contracted TIs 
// for the purpose of interfacing with ESS Products.  Code may be used in whole or in part 
// for the TIs products. Rights are subject to the restrictions below.
//
// This code may not be used for commercial purposes without a current TI agreement   
// in place with ESS.  The use of any sample code may incur liabilities for TI contractual 
// fees.  
//
// If the code is provided to eductational establishments for their own use then further 
// consent from ESS must be obtained before the code can be re-used for commercial gain.
//
// No warranty is provided . This header must be retained within the code and Copyright acknowleged as
// Parts (c) Education Software Solutions Ltd 2021 in version info.
//
// Code samples may be used to support other partners and no exclusivity is implied herein
//
// ---------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Text;
/// <summary>
/// Warning - This is work in progress as of 15/2/21 (Not released)
/// </summary>
namespace SIMS8V3Models
{
    public class TConductLookup : TLookups 
    {
    }
    public class ConductAchievementEvent : TConductGenericEvent
    {
        public TAchievementEventTypeRef AchievementEventType;
        public List<TLearnerAchievementEvent> Achievers;
        public List<TLearnerAchievementEventDocument> Notes;
    }

    public class TAchievementEventTypeRef : TReferenceClass { }
    public class TLocationRef : TReferenceClass { }
    public class TConductGenericEvent
    {
        public Guid ExternalID;
        public string Summary;
        public DateTime? EventDateTime;
        public TCreatedByRef CreatedBy;
        public TCreatedOnBehalfOfRef CreatedOnBehalfOf;
        public DateTime? CreatedOn;
        public TLocationRef Location;
    }
    public class TCreatedOnBehalfOfRef : TReferenceClass { }
    public class TCreatedByRef : TReferenceClass { }
    public class TLearnerAchievementEvent
    {
        public Guid ExternalID;
        public double? Points;
        public TLearnerRef Learner;
    }
    public class TConductBehaviourEvent : TConductGenericEvent
    {
        public TBehaviourEventTypeRef BehaviourEventType;
        public List<TLearnerBehaviourEvent> LearnersInvolved;
        public List<TBehaviourEventStaffInvolved> StaffInvolved;
        public List<TLearnerBehaviourEventDocument> Notes;
    }


    public class TBehaviourEventTypeRef : TReferenceClass { }
    public class TLearnerExclusion
    {
        public Guid ExternalID;
        public List<TExclusionReasonRefObj> ExclusionReasons;
        public TExclusionTypeRefObj ExclusionType;
        public float? NumberOfSchoolDays;
        public DateTime? ReinstatementDate;
        public List<TExclusionStatuses> ExclusionStatuses;
        public List<TExclusionNote> Notes;
        public DateTime? StartDateTime;
        public DateTime? EndDateTime;
        public int? SessionsMissed;

    }
    public class TExclusionLookup : TLookups { }
    public class TExclusionReasonRefObj : TReferenceClass { }
    public class TExclusionTypeRefObj : TReferenceClass { }
    public class TAchievementEventCategoryLevel : TEventCategoryLevel { }
    public class TBehaviourEventCategoryLevel : TEventCategoryLevel { }
    public class TEventCategoryLevel : TConductLookup 
    {
        public float? MinimumPoints;
        public float? MaximumPoints;
    }
    public class TBehaviourEventFollowUpStatus : TConductLookup { }
    public class BehaviourEventFollowUpAction : TConductLookup { }
    public class LearnerBehaviourEventRole : TConductLookup 
    {
        public float? UseDefaultPoints;
    }
    public class TBehaviourEventCategory : TConductLookup
    {
        public float? DefaultPoints;
        public TBehaviourEventCategoryLevelRef Level;
        public TBehaviourEventCategoryGroupRef Category;
    }
    public class TBehaviourEventCategoryLevelRef : TReferenceClass { }
    public class TBehaviourEventCategoryGroupRef : TReferenceClass { }
    public class TAchievementEventCategory : TConductLookup
    {
        public float? DefaultPoints;
        public TBehaviourEventCategoryLevelRef Level;
        public TBehaviourEventCategoryGroupRef Category;
    }
    public class TAchievementEventCategoryLevelRef : TReferenceClass { }
    public class TAchievementEventCategoryGroupRef : TReferenceClass { }
    public class TOwnerReference : TReferenceClass { }
    public class TLearnerRef : TReferenceClass { }
    public class TLearnerAchievementEventDocument : TNotes { }
    public class TLearnerBehaviourEventDocument : TNotes { }
    public class TLearnerRoleRef : TReferenceClass { }
    public class TLearnerBehaviourEvent 
    {
        public Guid ExternalID;
        public double? Points;
        public TLearnerRoleRef Role;
        public TLearnerRef Learner;
        public List<TLearnerBehaviourEvent> BehaviourEventFollowUp;

    }
    public class TBehaviourEventFollowUp
    {
        public Guid ExternalID;
        public DateTime? DueDate;
        public TStaffAssignedToRef StaffAssignedTo;
        public TBehaviourEventFollowUpActionRef BehaviourEventFollowUpAction;
        public TBehaviourEventFollowUpStatusRef BehaviourEventFollowUpStatus;
        public string Notes;

    }
    public class TStaffAssignedToRef :TReferenceClass { }
    public class TBehaviourEventFollowUpActionRef : TReferenceClass { }
    public class TBehaviourEventFollowUpStatusRef : TReferenceClass { }
    public class TBehaviourEventStaffInvolved 
    {
        public Guid ExternalID;
        public TStaffRef Staff;
        public TStaffInvolvementRef StaffInvolvement;
    }
    public class TStaffRef : TReferenceClass { }
    public class TStaffInvolvementRef : TReferenceClass { }
    public class TExclusionStatuses 
    {
        public Guid ExternalID;
        public TExclusionStatusRefObj Status;
        public TChangeReasonRefObj ChangeReason;
        public DateTime? ChangeDate;
    }
    public class TExclusionStatusRefObj :TReferenceClass { }
    public class TChangeReasonRefObj : TReferenceClass { }
    public class TExclusionNote : TNotes { }
    public class TExclusionMeetingType : TLookups { }
    public class TExclusionStatus : TLookups { }
    public class TExclusionStatusChangeReason : TLookups { }
    public class TExclusionReason : TLookups { }
    public class TExclusionType : TLookups { }

}
