﻿// ---------------------------------------------------------------------------------
// 
// Sample code is copyright (c) Education Software Solutions Ltd 2021
// 
// Education Software Solutions (Hereafter 'ESS') provide sample code to 
// ESS Technical Integrators (Hereafter 'TIs') under consultancy 
// or as part of our TI programme to assist in the production of applications and services
// to benefit mutual customers.
// 
// Sample code is supplied by the ESS TI Team and may be augmented / changed at any time.
//
// ESS grants non exclusive rights to use the code on an 'as is' basis to contracted TIs 
// for the purpose of interfacing with ESS Products.  Code may be used in whole or in part 
// for the TIs products. Rights are subject to the restrictions below.
//
// This code may not be used for commercial purposes without a current TI agreement   
// in place with ESS.  The use of any sample code may incur liabilities for TI contractual 
// fees.  
//
// If the code is provided to eductational establishments for their own use then further 
// consent from ESS must be obtained before the code can be re-used for commercial gain.
//
// No warranty is provided . This header must be retained within the code and Copyright acknowleged as
// Parts (c) Education Software Solutions Ltd 2021 in version info.
//
// Code samples may be used to support other partners and no exclusivity is implied herein
//
// ---------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Text;

namespace SIMS8V3Models
{
    public class TSchool : TEducationalEstablishments { }

    public class TRooms
    {
        public Guid ExternalID;
        public string ShortName;
        public string TelephoneNumber;
        public Nullable<int> MaximumGroupSize;
        public Nullable<int> Area;
        public TRoomMainUser RoomMainUser;
        public TEducationalEstablishmentSite RoomLocation;
        public List<TRoomNote> Notes;


    }
    public class TRoomMainUser
    {
        public Guid ExternalID;
        public string Type;
    }
    public class TRoomNote
    {
        public Guid ExternalID;
        public string Summary;
        public bool Confidential;
        public string Note;
        public string Attachments;
    }
    /// <summary>
    /// 
    /// Known values
    /// DENINumber
    /// "GoverningBodyNumber "
    /// "ISCReferenceNumber "
    /// "UKPRN"
    /// "URN"
    /// </summary>
    public class TReferenceNumberType
    {
        public Guid ExternalID;
        public string Type;

    }
    public class TEstablishmentReferenceNumber
    {
        //public Guid ExternalID;
        public string ReferenceNumber;
        public string ReferenceNumberType;
        // public TReferenceNumberType ReferenceNumberType;
    }
    public class TEducationalEstablishmentLookups
    {
        public Guid ExternalID;
        public TResourceProviderRef ResourceProvider;
        public string Description;
        public Nullable<int> DisplayOrder;
        public Nullable<bool> IsVisible;
        public string LookupType;
    }
    public class TEducationAuthorityRef : TReferenceClass { }
    public class TEducationalEstablishmentType : TReferenceClass { }
    public class TGovernanceTypeRef : TReferenceClass { }
    public class TEducationPhaseRef : TReferenceClass { }
    public class TIntakeTypeRef : TReferenceClass { }
    public class TExtendedServiceTypeRef : TReferenceClass { }

    public class TEducationalEstablishments
    {
        public Guid ExternalID;
        public string Name;
        public string PreferredName;
        public string TelephoneNumber;
        public string EmailAddress;
        public string FaxNumber;
        public string Website;
        public string Logo;
        public string OrganisationID;
        public TAddress Address;
        public List<TEstablishmentReferenceNumber> ReferenceNumbers;
        public TEducationAuthorityRef EducationAuthority;
        public TEducationalEstablishmentTypeRef EducationalEstablishmentType;
        public TGovernanceTypeRef GovernanceType;
        public TEducationPhaseRef EducationPhase;
        public TIntakeTypeRef IntakeType;
        public TExtendedServiceTypeRef ExtendedServices;
        public List<TEducationEstablishmentFacility> Facilities;
        public List<TEducationalEstablishmentSite> Sites;
        public List<TTeachingMediumRef> TeachingMediums;
        public List<TEducationalEstablishmentContact> Contacts;
        public TResourceProviderRef ResourceProvider;

    }
    public class TEducationalEstablishmentTypeRef : TReferenceClass { }
    public class TEducationEstablishmentFacility
    {
        public int? Capacity;
        public int? MinimumAge;
        public int? MaximumAge;
        public string FacilityType;
    }
    public class TEducationalEstablishmentSite
    {
        public Guid ExternalID;
        public string Name;
        public string ShortName;
        public string TelephoneNumber;
        public string MobileNumber;
        public string EmailAddress;
        public string FaxNumber;
        public bool? IsDefaultSite;
        public string SiteContactName;
        public string WebsiteAddress;
        public TAddress Address;
        public List<TBuilding> Buildings;
    }
    public class TEstablishmentContact
    {
        public Guid ExternalID;
        public string Telephone;
        public string KeyHolder;
        public string Area;
        public TContactRef Contact;
    }
    public class TContactRef : TReferenceClass { }
    public class TBuilding
    {
        public Guid ExternalID;
        public string Name;
        public string ShortName;
        public string TelephoneNumber;
        public string MobileNumber;
        public string EmailAddress;
        public TAddress Address;
    }
    public class TTeachingMediumRef : TReferenceClass { }
    public class TEducationalEstablishmentContact { }
}
