﻿// ---------------------------------------------------------------------------------
// 
// Sample code is copyright (c) Education Software Solutions Ltd 2021
// 
// Education Software Solutions (Hereafter 'ESS') provide sample code to 
// ESS Technical Integrators (Hereafter 'TIs') under consultancy 
// or as part of our TI programme to assist in the production of applications and services
// to benefit mutual customers.
// 
// Sample code is supplied by the ESS TI Team and may be augmented / changed at any time.
//
// ESS grants non exclusive rights to use the code on an 'as is' basis to contracted TIs 
// for the purpose of interfacing with ESS Products.  Code may be used in whole or in part 
// for the TIs products. Rights are subject to the restrictions below.
//
// This code may not be used for commercial purposes without a current TI agreement   
// in place with ESS.  The use of any sample code may incur liabilities for TI contractual 
// fees.  
//
// If the code is provided to eductational establishments for their own use then further 
// consent from ESS must be obtained before the code can be re-used for commercial gain.
//
// No warranty is provided . This header must be retained within the code and Copyright acknowleged as
// Parts (c) Education Software Solutions Ltd 2021 in version info.
//
// Code samples may be used to support other partners and no exclusivity is implied herein
//
// ---------------------------------------------------------------------------------

using Microsoft.VisualBasic.CompilerServices;
using System;
using System.Collections.Generic;
using System.Text;

namespace SIMS8V3Models
{
    public class TPastoralGroupMembers
    {
        public Guid ExternalID;
        public string PastoralGroupType;
        public Nullable<DateTime> StartDate;
        public Nullable<DateTime> EndDate;
        public TMember Member;
        public TPastoralGroup PastoralGroup;
    }

    public class TPastoralGroupSupervisions
    {
        public Guid ExternalID;
        public string PastoralGroupType;
        public Nullable<DateTime> StartDate;
        public Nullable<DateTime> EndDate;
        public TSupervisor Supervisor;
        public TPastoralGroup PastoralGroup;
        public TSupervisorRole SupervisorRole;

    }
    public class TPastoralGroupType
    {
        public Guid ExternalID;
        public string Type;
    }
    public class TPastoralGroup
    {
        public Guid ExternalID;
        public string Type;
    }
    public class TMember
    {
        public Guid ExternalID;
        public string Type;
    }
    public class TSupervisor
    {
        public Guid ExternalID;
        public string Type;
    }
    public class TSupervisorRole
    {
        public Guid ExternalID;
        public string Type;
    }
    public class TPastoralGroupDefinition
    {
        public Guid ExternalID;
        //public TPastoralGroupType PastoralGroupType;
        public string PastoralGroupType;
        public string ShortName;
        public string FullName;
        public Nullable<int> DisplayOrder;
        public List<TEffectiveDate> EffectiveDates;
        public List<TAssociatedPastoralGroup> AssociatedGroups;

    }
    public class TAssociatedPastoralGroup
    {
        public Guid ExternalID;
        public Nullable<DateTime> StartDate;
        public Nullable<DateTime> EndDate;
        public string AssociationType;
        public TPastoralGroupReference PastoralGroupReference;
    }
    public class TPastoralGroupReference
    {
        public Guid ExternalID;
        public string Type;
    }
    public class TEffectiveDate
    {
        public Guid ExternalID;
        public Nullable<DateTime> StartDate;
        public Nullable<DateTime> EndDate;
    }
    public class TPastoralGroupLookups
    {
        public Guid ExternalID;
        public string LookUpType;
        public string Code;
        public string Description;
        public Nullable<int> DisplayOrder;
        public bool IsVisible;
        public TResourceProvider ResourceProvider;


    }
    public class TResourceProvider
    {
        public Guid ExternalID;
        public string Type;
    }
}
