﻿// ---------------------------------------------------------------------------------
// 
// Sample code is copyright (c) Education Software Solutions Ltd 2021
// 
// Education Software Solutions (Hereafter 'ESS') provide sample code to 
// ESS Technical Integrators (Hereafter 'TIs') under consultancy 
// or as part of our TI programme to assist in the production of applications and services
// to benefit mutual customers.
// 
// Sample code is supplied by the ESS TI Team and may be augmented / changed at any time.
//
// ESS grants non exclusive rights to use the code on an 'as is' basis to contracted TIs 
// for the purpose of interfacing with ESS Products.  Code may be used in whole or in part 
// for the TIs products. Rights are subject to the restrictions below.
//
// This code may not be used for commercial purposes without a current TI agreement   
// in place with ESS.  The use of any sample code may incur liabilities for TI contractual 
// fees.  
//
// If the code is provided to eductational establishments for their own use then further 
// consent from ESS must be obtained before the code can be re-used for commercial gain.
//
// No warranty is provided . This header must be retained within the code and Copyright acknowleged as
// Parts (c) Education Software Solutions Ltd 2021 in version info.
//
// Code samples may be used to support other partners and no exclusivity is implied herein
//
// ---------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Text;

namespace SIMS8V3Models.Models
{
    public class Utilities
    {
        public static string ToJSONDateTimeFromString(string sd)
        {
            return ToJSONDateTime(DateTime.Parse(sd));
        }
        public static string ToJSONDateTime(Nullable<DateTime> sdn)
        {
            DateTime sd;
            if (sdn == null)
            {
                return "null";
            }
            else
            {
                sd = (DateTime)sdn;
            }
            StringBuilder d = new StringBuilder();
            d.Append(sd.Year);
            d.Append("-");
            if (sd.Month < 10)
            {
                d.Append("0" + sd.Month.ToString());
            }
            else
            {
                d.Append(sd.Month);
            }
            d.Append("-");
            if (sd.Day < 10)
            {
                d.Append("0" + sd.Day.ToString());
            }
            else
            {
                d.Append(sd.Day);
            }
            d.Append("T");
            if (sd.Hour < 10)
            {
                d.Append("0" + sd.Hour.ToString());
            }
            else
            {
                d.Append(sd.Hour);
            }
            d.Append(":");
            if (sd.Minute < 10)
            {
                d.Append("0" + sd.Minute.ToString());
            }
            else
            {
                d.Append(sd.Minute);
            }
            d.Append(":");
            if (sd.Second < 10)
            {
                d.Append("0" + sd.Second.ToString());
            }
            else
            {
                d.Append(sd.Second);
            }
            d.Append("Z");
            return d.ToString();
        }
    }
}
